Package com.orchestranetworks.ui

# Interface UIResponseContext

All Superinterfaces:
  `UIBodyWriter`, `UIComponentWriter`, `UIContext`, `UIDependencyRegisterer`, `UIJavaScriptWriter`, `UIResourceLocator`, `UISessionContext`

@Deprecated public interface UIResponseContext extends UIContext, UIComponentWriter
Deprecated.
From 5.8.0, please use the new API `UICustomWidget` instead.
Encapsulates an HTTP response in order for a bean editor to generate its part of the DHTML page, including the building of standard EBX® components.

See Also:
  - `UIBeanEditor`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addComboBox(Path aPath)`
  Deprecated.
  Replaced by `UIFormWriter.newComboBox(Path)` and `UIFormWriter.addWidget(UIWidget)`
  `void`
  `addComboBox(UIComboBox aWidget)`
  Deprecated.
  please use `newComboBox(Path)` and `addWidget(UIWidget)`
  `void`
  `addEmptyFieldButton(String buttonId, boolean isDisabled, String aJavaScriptCommand)`
  Deprecated.
  Replaced by `WidgetWriter.addEmptyFieldButton(String, boolean, String)`
  `void`
  `addFormRow(UIFormRow aFormRow)`
  Deprecated.
  Replaced by `UIFormWriter.addFormRow(UIFormRow)`
  `void`
  `addFormRow(UIFormRow aFormRow, UIWidget aWidget)`
  Deprecated.
  Replaced by `UIFormWriter.addFormRow(UIFormRow, UIWidget)`
  `void`
  `addFormRow(UIWidget aWidget)`
  Deprecated.
  Replaced by `UIFormWriter.addFormRow(UIWidget)`
  `void`
  `addFormRowBestMatchingComponent(Path nodePath)`
  Deprecated.
  Replaced by `UIFormWriter.addFormRow(Path)`
  `void`
  `addFormRowBestMatchingComponent(Path nodePath, boolean enableIcon)`
  Deprecated.
  Replaced by `UIFormWriter.newFormRow(Path)`, `UIFormRow.setIconDisplayed(boolean)` and `UIFormWriter.addFormRow(UIFormRow)`
  `void`
  `addFormRowBestMatchingDisplay(Path nodePath)`
  Deprecated.
  Replaced by `UIFormWriter.newBestMatching(Path)`, `UIWidget.setEditorDisabled(boolean)` and `UIFormWriter.addFormRow(UIWidget)`
  `void`
  `addFormRowBestMatchingDisplay(Path nodePath, boolean enableIcon)`
  Deprecated.
  Replaced by `UIFormWriter.newBestMatching(Path)`, `UIWidget.setEditorDisabled(boolean)`, `UIFormWriter.newFormRow(Path)`, `UIFormRow.setIconDisplayed(boolean)` and `UIFormWriter.addFormRow(UIFormRow, UIWidget)`
  `void`
  `addFormRowBestMatchingEditor(Path nodePath)`
  Deprecated.
  Replaced by `UIFormWriter.addFormRow(Path)`
  `void`
  `addFormRowBestMatchingEditor(Path nodePath, boolean enableIcon)`
  Deprecated.
  Replaced by `UIFormWriter.newFormRow(Path)`, `UIFormRow.setIconDisplayed(boolean)` and `UIFormWriter.addFormRow(UIFormRow)`
  `UIJavaScriptWriter`
  `addJS_getNodeValue(Path aPath)`
  Deprecated.
  Replaced by `UIFormWriter.addJS_getNodeValue(Path)`
  `UIJavaScriptWriter`
  `addJS_setNodeValue(String aVarName, Path aPath)`
  Deprecated.
  Replaced by `UIFormWriter.addJS_setNodeValue(String, Path)`
  `void`
  `addServiceButton(Path aPath)`
  Deprecated.
  Replaced by `WidgetWriter.addServiceButton(Path)`
  `void`
  `addUIBean(Path aPath, String htmlAttributes)`
  Deprecated.
  please use `addWidget(Path)`
  `void`
  `addUIBestMatchingComponent(Path aPath, String htmlAttributes)`
  Deprecated.
  please use `addWidget(Path)`
  `void`
  `addUIBestMatchingDisplay(Path aPath, UIRenderingMode renderingMode, String htmlAttributes)`
  Deprecated.
  please use `newBestMatching(Path)`, `UIWidget.setEditorDisabled(boolean)` and `addWidget(UIWidget)`
  `void`
  `addUIBestMatchingDisplay(Path aPath, String htmlAttributes)`
  Deprecated.
  please use `newBestMatching(Path)`, `UIWidget.setEditorDisabled(boolean)` and `addWidget(UIWidget)`
  `void`
  `addUIBestMatchingEditor(Path aPath, String htmlAttributes)`
  Deprecated.
  please use `addWidget(Path)`
  `void`
  `addUICheckBox(int index, Path aPath, String htmlAttributes)`
  Deprecated.
  please use `newCheckBox(Path)`, `UIAtomicWithEnumerationItem.setIndex(int)` and `addWidget(UIWidget)`
  `void`
  `addUICheckBox(Path aPath, String htmlAttributes)`
  Deprecated.
  please use `newCheckBox(Path)` and `addWidget(UIWidget)`
  `void`
  `addUICheckBoxGroup(Path aPath, String htmlAttributes)`
  Deprecated.
  please use `newCheckBoxGroup(Path)` and `addWidget(UIWidget)`
  `void`
  `addUICheckBoxGroup(Path aPath, String htmlAttributes, Nomenclature aSpecificNomenclature)`
  Deprecated.
  please use `newCheckBoxGroup(Path)`, `UIAtomicWithEnumeration.setSpecificNomenclature(Nomenclature)` and `addWidget(UIWidget)`
  `void`
  `addUICheckBoxGroup(Path aPath, String htmlAttributes, String htmlSeparator)`
  Deprecated.
  please use `newCheckBoxGroup(Path)`, `UICheckBoxGroup.setColumnsNumber(int)` (instead of htmlSeparator) and `addWidget(UIWidget)`
  `void`
  `addUICheckBoxGroup(Path aPath, String htmlAttributes, String htmlSeparator, Nomenclature aSpecificNomenclature)`
  Deprecated.
  please use `newCheckBoxGroup(Path)`, `UICheckBoxGroup.setColumnsNumber(int)` (instead of htmlSeparator), `UIAtomicWithEnumeration.setSpecificNomenclature(Nomenclature)` and `addWidget(UIWidget)`
  `void`
  `addUIComplexEditor(Path aPath, String htmlAttributes)`
  Deprecated.
  please use `addWidget(Path)`
  `void`
  `addUIDescription(Path aPath)`
  Deprecated.
  Replaced by `WidgetWriter.addUIDescription(Path)`
  `void`
  `addUIDisplayValue(Path aPath)`
  Deprecated.
  Replaced by `WidgetWriter.addUIDisplayValue(Path)`
  `void`
  `addUIDropDownBox(Path aPath, String htmlAttributes)`
  Deprecated.
  please use `newDropDownList(Path)` and `addWidget(UIWidget)`
  `void`
  `addUIDropDownBox(Path aPath, String htmlAttributes, Nomenclature aSpecificNomenclature)`
  Deprecated.
  please use `newDropDownList(Path)`, `UIAtomicWithEnumeration.setSpecificNomenclature(Nomenclature)` and `addWidget(UIWidget)`
  `void`
  `addUIDropDownBoxMultiple(Path aPath, String htmlAttributes)`
  Deprecated.
  please use `newListBox(Path)` and `addWidget(UIWidget)`
  `void`
  `addUILabel(Path aPath)`
  Deprecated.
  Replaced by `WidgetWriter.addUILabel(Path)`
  `void`
  `addUIListSearch(Path aPath, String htmlAttributes)`
  Deprecated.
  please use `newComboBox(Path)` and `addWidget(UIWidget)`
  `void`
  `addUIListSearch(Path aPath, String htmlAttributes, Nomenclature aSpecificNomenclature)`
  Deprecated.
  please use `newComboBox(Path)`, `UIAtomicWithEnumeration.setSpecificNomenclature(Nomenclature)` and `addWidget(UIWidget)`
  `void`
  `addUIOccurrenceEditor(Path aPath, String htmlAttributes)`
  Deprecated.
  The default occurrence editor can only work with the default multi-occurrence editor.
  `void`
  `addUIPasswordInputField(Path aPath, String htmlAttributes)`
  Deprecated.
  please use `newPassword(Path)` and `addWidget(UIWidget)`
  `void`
  `addUIRadioButton(Path aPath, String htmlAttributes, boolean setCode, boolean setLabel, int index)`
  Deprecated.
  please use `newRadioButton(Path)`, `UIWidget.setEditorDisabled(boolean)`, `UIAtomicWithEnumerationItem.setLabelEnabled(boolean)`, `UIAtomicWithEnumerationItem.setIndex(int)` and `addWidget(UIWidget)`
  `void`
  `addUIRadioButtonGroup(Path aPath, String htmlAttributes)`
  Deprecated.
  please use `newRadioButtonGroup(Path)` and `addWidget(UIWidget)`
  `void`
  `addUIRadioButtonGroup(Path aPath, String htmlAttributes, String htmlSeparator)`
  Deprecated.
  please use `newRadioButtonGroup(Path)`, `UIRadioButtonGroup.setColumnsNumber(int)` (instead of htmlSeparator) and `addWidget(UIWidget)`
  `void`
  `addUITextAreaField(Path aPath, String htmlAttributes)`
  Deprecated.
  please use `newTextBox(Path)`, `UITextBox.setMultiLine(boolean)` and `addWidget(UIWidget)`
  `void`
  `addUITextHiddenInputField(Path aPath, String htmlAttributes)`
  Deprecated.
  please use `newTextBox(Path)` and `addWidget(UIWidget)` with a <div style="display:none;">...</div> surrounding you widget.
  Example:
  `void`
  `addUITextInputField(Path aPath, String htmlAttributes)`
  Deprecated.
  please use `newTextBox(Path)` and `addWidget(UIWidget)`
  `void`
  `addUIValidationMessage(Path aPath)`
  Deprecated.
  Replaced by `WidgetWriter.addUIValidationMessage(Path)`
  `void`
  `addWidget(Path aPath)`
  Deprecated.
  Replaced by `UIFormWriter.addWidget(Path)`
  `void`
  `addWidget(UIWidget aWidget)`
  Deprecated.
  Replaced by `UIFormWriter.addWidget(UIWidget)`
  `void`
  `doEnsureValueIsDefined()`
  Deprecated.
  Pre-instantiates a value for the current node.
  `void`
  `enableEscapedHtml(boolean enabled)`
  Deprecated.
  See `UIBeanEditorV4`.
  `int`
  `getNextHtmlTabIndex()`
  Deprecated.
  `TabIndexes` are no longer used in forms, the default order (no `tabIndex`) is preferable.
  `Path`
  `getPrefixedPath(Path aPath)`
  Deprecated.
  Replaced by `UIFormWriter.getPrefixedPath(Path)`
  `UIRenderingMode`
  `getRenderingMode()`
  Deprecated.
  Returns the current rendering mode.
  `UITableCellStyleHandler`
  `getTableCellStyleHandler()`
  Deprecated.
  Replaced by `WidgetWriter.getTableCellStyleHandler()`
  `ValueContextForValidation`
  `getValueContext()`
  Deprecated.
  Replaced by `WidgetDisplayContext.getValueContext()`
  `ValueContextForValidation`
  `getValueContext(Path aPath)`
  Deprecated.
  Replaced by `WidgetDisplayContext.getValueContext(Path)`
  `boolean`
  `isEscapedHtmlEnable()`
  Deprecated.
  See `UIBeanEditorV4`.
  `UIResponseContext`
  `jsBufferAddJavaScriptExpression(String aJavaScriptExpression)`
  Deprecated.
  This method is inactive except if extending `UIBeanEditorV4`.
  `UIResponseContext`
  `jsBufferAddString(String aString)`
  Deprecated.
  Use `UIJavaScriptWriter.addJS(String)` or `UIBodyWriter.add(String)` instead.
  `UIResponseContext`
  `jsBufferEndOfLine()`
  Deprecated.
  This method is not used unless extending `UIBeanEditorV4`.
  `UIResponseContext`
  `jsBufferInitalize()`
  Deprecated.
  This method is not used unless extending `UIBeanEditorV4`.
  `UIResponseContext`
  `jsBufferNewLine()`
  Deprecated.
  This method is not used unless extending `UIBeanEditorV4`.
  `UIResponseContext`
  `jsBufferReenable(boolean isJsBufferWritingModeTemporaryDisabled)`
  Deprecated.
  This method is inactive except if extending `UIBeanEditorV4`.
  `boolean`
  `jsBufferTemporaryDisable()`
  Deprecated.
  This method is inactive except if extending `UIBeanEditorV4`.
  `UIWidget`
  `newBestMatching(Path aPath)`
  Deprecated.
  Replaced by `UIFormWriter.newBestMatching(Path)`
  `UICheckBox`
  `newCheckBox(Path aPath)`
  Deprecated.
  Replaced by `UIFormWriter.newCheckBox(Path)`
  `UICheckBoxGroup`
  `newCheckBoxGroup(Path aPath)`
  Deprecated.
  Replaced by `UIFormWriter.newCheckBoxGroup(Path)`
  `UIColorPicker`
  `newColorPicker(Path aPath)`
  Deprecated.
  Replaced by `UIFormWriter.newColorPicker(Path)`
  `UIComboBox`
  `newComboBox(Path aPath)`
  Deprecated.
  Replaced by `UIFormWriter.newComboBox(Path)`
  `UIDateTime`
  `newDateTime(Path aPath)`
  Deprecated.
  Replaced by `UIFormWriter.newDateTime(Path)`
  `UIDropDownList`
  `newDropDownList(Path aPath)`
  Deprecated.
  Replaced by `UIFormWriter.newDropDownList(Path)`
  `UIFormGroup`
  `newFormGroup(Path aPath)`
  Deprecated.
  Replaced by `UIFormWriter.newFormGroup(Path)`
  `UIFormRow`
  `newFormRow(Path aPath)`
  Deprecated.
  Replaced by `UIFormWriter.newFormRow(Path)`
  `UIListBox`
  `newListBox(Path aPath)`
  Deprecated.
  Replaced by `UIFormWriter.newListBox(Path)`
  `UIPassword`
  `newPassword(Path aPath)`
  Deprecated.
  Replaced by `UIFormWriter.newPassword(Path)`
  `UIRadioButton`
  `newRadioButton(Path aPath)`
  Deprecated.
  Replaced by `UIFormWriter.newRadioButton(Path)`
  `UIRadioButtonGroup`
  `newRadioButtonGroup(Path aPath)`
  Deprecated.
  Replaced by `UIFormWriter.newRadioButtonGroup(Path)`
  `UITable`
  `newTable(Path aPath)`
  Deprecated.
  Replaced by `UIFormWriter.newTable(Path)`
  `UITextBox`
  `newTextBox(Path aPath)`
  Deprecated.
  Replaced by `UIFormWriter.newTextBox(Path)`
  `UITextBox`
  `newTextBox(Path aPath, String textBoxId)`
  Deprecated.
  Replaced by `UIFormWriter.newTextBox(Path)`
  `void`
  `setCellContentWithButtonOnRight(String aString, UIButtonSpec aButton)`
  Deprecated.
  This method can be used to include content in a table cell with a button to the right.
  `void`
  `startFormGroup(Path aPath)`
  Deprecated.
  Replaced by `UIFormWriter.startFormGroup(Path)`
  `void`
  `startFormRow(Path pathForLabel)`
  Deprecated.
  Replaced by `UIFormWriter.startFormRow(Path)`
  `void`
  `startFormRow(Path pathForLabel, boolean enableIcon)`
  Deprecated.
  Replaced by `UIFormWriter.newFormRow(Path)`, `UIFormRow.setIconDisplayed(boolean)` and `UIComponentWriter.startFormRow(UIFormRow)`

  ### Methods inherited from interface com.orchestranetworks.ui.UIBodyWriter

  `add, add, add, add_cr, add_cr, addSafeAttribute, addSafeAttribute, addSafeInnerHTML, addSafeInnerHTML`

  ### Methods inherited from interface com.orchestranetworks.ui.UIComponentWriter

  `addButtonHelp, addButtonJavaScript, addButtonJavaScriptToggle, addUILabel, addUserAvatar, buildButtonPreview, buildButtonPreview, buildButtonPreview, endBorder, endExpandCollapseBlock, endFormGroup, endFormRow, endTableFormRow, newExpandCollapseBlock, newFormGroup, newFormRow, startBorder, startBorder, startBorder, startExpandCollapseBlock, startExpandCollapseBlock, startFormGroup, startFormGroup, startFormRow, startFormRow, startFormRow, startFormRow, startTableFormRow`

  ### Methods inherited from interface com.orchestranetworks.ui.UIContext

  `displayOccurrence, getHierarchyMember, getHierarchyNode, getLocale, getNode, getNode, getPathForListOccurrence, getPathForListOccurrence, getPathInAdaptation, getSession, getValue, getValue, getWebName, getWebNameFor, getWebNameForPath, getWebNameOfParent, isCreatingRecord, isDuplicatingRecord`

  ### Methods inherited from interface com.orchestranetworks.ui.UIDependencyRegisterer

  `addJavaScriptDependency`

  ### Methods inherited from interface com.orchestranetworks.ui.UIJavaScriptWriter

  `addJS, addJS_addResizeWorkspaceListener, addJS_cr, addJS_cr, addJS_openPreviewImage, addJS_openPreviewImageFromVar, addJS_setButtonDisabled, addJS_setExpandCollapseBlockExpanded, addJS_setStateToToggleButton, addJS_switchToPerspective, addJS_switchToPerspectiveAction`

  ### Methods inherited from interface com.orchestranetworks.ui.UIResourceLocator

  `createWebComponentForRootSession, createWebComponentForSubSession, getURLForAjaxComponent, getURLForAjaxComponent, getURLForPerspectiveSelection, getURLForPerspectiveSelection, getURLForResource, getURLForResource, getURLForResource, getURLForResource, getURLForResource, getURLForRest, getURLForSelection, getURLForSelection, getURLForSelection, getURLForSelection, getURLForSelection, getURLForSelection, getURLForViewSelection`

  ### Methods inherited from interface com.orchestranetworks.ui.UISessionContext

  `getLocale, getSession`

- ## Method Details

  - ### getRenderingMode

    UIRenderingMode getRenderingMode()
    Deprecated.
    Returns the current rendering mode.

  - ### getValueContext

    @Deprecated ValueContextForValidation getValueContext()
    Deprecated.
    Replaced by `WidgetDisplayContext.getValueContext()`
    Returns the validation context of the current node.

  - ### getValueContext

    @Deprecated ValueContextForValidation getValueContext(Path aPath)
    Deprecated.
    Replaced by `WidgetDisplayContext.getValueContext(Path)`
    Returns the validation context of the specified node.

  - ### addEmptyFieldButton

    @Deprecated void addEmptyFieldButton(String buttonId, boolean isDisabled, String aJavaScriptCommand)
    Deprecated.
    Replaced by `WidgetWriter.addEmptyFieldButton(String, boolean, String)`
    Adds a button with the built-in "empty field" button look and feel.

    A click on this button will execute the given JavaScript command.

  - ### addServiceButton

    @Deprecated void addServiceButton(Path aPath)
    Deprecated.
    Replaced by `WidgetWriter.addServiceButton(Path)`
    Adds a service menu button to the specified node.

    If no services are defined for the node, or if no services are granted to the user according to access rights, no button will be added.

    The standard position of the service button is to the right of the component; the standard position of the validation message is below the component.

    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
    Since:
      5.4.2
    See Also:
      - `addUIValidationMessage(Path)`

  - ### addUIBestMatchingComponent

    @Deprecated void addUIBestMatchingComponent(Path aPath, String htmlAttributes)
    Deprecated.
    please use `addWidget(Path)`
    Adds the user interface component corresponding to the specified field or group. "Best matching" means that the component will be adapted to the data type and facets of the node.

    If the field is hidden according to the permission rules, then this method does nothing. If the field is read-only according to the permission rules, then a read-only component is displayed. This method does not take into account the `defaultView` property (since its application is restricted to the default view, which is not the case here).

    This method calls `addUIBestMatchingDisplay(Path, String)` or `addUIBestMatchingEditor(Path, String)` according to the rendering mode.

    A common example:

         UIResponseContext.addUIBestMatchingComponent(Path.SELF, "")

    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
      `htmlAttributes` - optional, the string is added to the attributes of the main HTML component
    Since:
      5.2.0
    See Also:
      - `addWidget(Path)`

  - ### addUIBestMatchingDisplay

    @Deprecated void addUIBestMatchingDisplay(Path aPath, String htmlAttributes)
    Deprecated.
    please use `newBestMatching(Path)`, `UIWidget.setEditorDisabled(boolean)` and `addWidget(UIWidget)`
    Adds the user interface component corresponding to the specified field or group, in 'read-only' mode. "Best matching", means that the component will be adapted to the data type and facets of the node.

    A common example:

         UIResponseContext.addUIBestMatchingDisplay(Path.SELF, "")

    If the field is hidden according to the permission rules, then this method does nothing. This method does not take into account the `defaultView` property (since its application is restricted to the default view, which is not the case here).

    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
      `htmlAttributes` - optional, the string is added to the attributes of the main HTML component.
    Since:
      5.2.0
    See Also:
      - `newBestMatching(Path)`
      - `UIWidget.setEditorDisabled(boolean)`
      - `addWidget(UIWidget)`

  - ### addUIBestMatchingDisplay

    @Deprecated void addUIBestMatchingDisplay(Path aPath, UIRenderingMode renderingMode, String htmlAttributes)
    Deprecated.
    please use `newBestMatching(Path)`, `UIWidget.setEditorDisabled(boolean)` and `addWidget(UIWidget)`
    Adds the user interface component corresponding to the specified field or group, in 'read-only' mode. "Best matching" means that the component will be adapted to the data type and facets of the node.

    If the field is hidden according to the permission rules, then this method does nothing. This method does not take into account the `defaultView` property (since its application is restricted to the default view, which is not the case here).

    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
      `htmlAttributes` - optional, the string is added to the attributes of the main HTML component.
    See Also:
      - `newBestMatching(Path)`
      - `UIWidget.setEditorDisabled(boolean)`
      - `addWidget(UIWidget)`

  - ### addUIBestMatchingEditor

    @Deprecated void addUIBestMatchingEditor(Path aPath, String htmlAttributes)
    Deprecated.
    please use `addWidget(Path)`
    Adds the user interface component corresponding to the specified field or group, in 'read-write' mode. "Best matching" means that the component will be adapted to the data type and the facets of the node.

    A common example:

         UIResponseContext.addUIBestMatchingEditor(Path.SELF, "")

    If the field is hidden according to the permission rules, then this method does nothing. If the field is read-only according to the permission rules, then a read-only component is displayed. This method does not take into account the `defaultView` property (since its application is restricted to the default view, which is not the case here).

    Note: The use of the argument `htmlAttributes` has limited backward compatibility, and therefore requires extensive testing on any browser that could be used by the end user. Specifically, if the underlying type SchemaNode.getFacetEnumeration() depends on an enumeration, the new combo box will not be used if `htmlAttributes` is not `null` or empty; instead the older `UIListSearch` will be used for backward compatibility.

    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, it is advised to use a relative path.
      `htmlAttributes` - optional, the string is added to the attributes of the main HTML component (see note).
    See Also:
      - `addWidget(Path)`

  - ### addUIDisplayValue

    @Deprecated void addUIDisplayValue(Path aPath)
    Deprecated.
    Replaced by `WidgetWriter.addUIDisplayValue(Path)`
    Displays the value of the specified field.
    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.

  - ### addUICheckBox

    @Deprecated void addUICheckBox(Path aPath, String htmlAttributes)
    Deprecated.
    please use `newCheckBox(Path)` and `addWidget(UIWidget)`
    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
      `htmlAttributes` - optional, the string is added to the attributes of the main HTML component
    See Also:
      - `newCheckBox(Path)`
      - `addWidget(UIWidget)`

  - ### addUICheckBox

    @Deprecated void addUICheckBox(int index, Path aPath, String htmlAttributes)
    Deprecated.
    please use `newCheckBox(Path)`, `UIAtomicWithEnumerationItem.setIndex(int)` and `addWidget(UIWidget)`
    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
      `htmlAttributes` - optional, the string is added to the attributes of the main HTML component
    See Also:
      - `newCheckBox(Path)`
      - `UIAtomicWithEnumerationItem.setIndex(int)`
      - `addWidget(UIWidget)`

  - ### addUICheckBoxGroup

    @Deprecated void addUICheckBoxGroup(Path aPath, String htmlAttributes)
    Deprecated.
    please use `newCheckBoxGroup(Path)` and `addWidget(UIWidget)`
    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
      `htmlAttributes` - optional, the string is added to the attributes of the main HTML component
    See Also:
      - `newCheckBoxGroup(Path)`
      - `addWidget(UIWidget)`

  - ### addUICheckBoxGroup

    @Deprecated void addUICheckBoxGroup(Path aPath, String htmlAttributes, String htmlSeparator)
    Deprecated.
    please use `newCheckBoxGroup(Path)`, `UICheckBoxGroup.setColumnsNumber(int)` (instead of htmlSeparator) and `addWidget(UIWidget)`
    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
      `htmlAttributes` - optional, the string is added to the attributes of the main HTML component
      `htmlSeparator` - optional, a specific HTML string as value separator (display on one line: `&nbsp;`, or in a column: `<br>`)
    See Also:
      - `newCheckBoxGroup(Path)`
      - `UICheckBoxGroup.setColumnsNumber(int)`
      - `addWidget(UIWidget)`

  - ### addUICheckBoxGroup

    @Deprecated void addUICheckBoxGroup(Path aPath, String htmlAttributes, Nomenclature aSpecificNomenclature)
    Deprecated.
    please use `newCheckBoxGroup(Path)`, `UIAtomicWithEnumeration.setSpecificNomenclature(Nomenclature)` and `addWidget(UIWidget)`
    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
      `htmlAttributes` - optional, the string is added to the attributes of the main HTML component
      `aSpecificNomenclature` - specifies the value-label pairs to use specifically for this component.
    See Also:
      - `newCheckBoxGroup(Path)`
      - `UIAtomicWithEnumeration.setSpecificNomenclature(Nomenclature)`
      - `addWidget(UIWidget)`

  - ### addUICheckBoxGroup

    @Deprecated void addUICheckBoxGroup(Path aPath, String htmlAttributes, String htmlSeparator, Nomenclature aSpecificNomenclature)
    Deprecated.
    please use `newCheckBoxGroup(Path)`, `UICheckBoxGroup.setColumnsNumber(int)` (instead of htmlSeparator), `UIAtomicWithEnumeration.setSpecificNomenclature(Nomenclature)` and `addWidget(UIWidget)`
    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
      `htmlAttributes` - optional, the string is added to the attributes of the main HTML component
      `htmlSeparator` - optional, a specific HTML string as value separator (display in one line: `&nbsp;`, or in column: `<br>`)
      `aSpecificNomenclature` - specifies the "value-label" pairs to use specifically for this component.
    See Also:
      - `newCheckBoxGroup(Path)`
      - `UICheckBoxGroup.setColumnsNumber(int)`
      - `UIAtomicWithEnumeration.setSpecificNomenclature(Nomenclature)`
      - `addWidget(UIWidget)`

  - ### addComboBox

    @Deprecated void addComboBox(Path aPath)
    Deprecated.
    Replaced by `UIFormWriter.newComboBox(Path)` and `UIFormWriter.addWidget(UIWidget)`
    Adds the combo box component for user search and selection in a list.

    For simple HTML drop-down lists, this widget facilitates selection in the list, especially for large enumerations. Another benefit is its low data transfer cost between the end-user browser and the application server.

    If called for a node under an aggregated list, the given path must be indexed and relative. To get such a path, use the method `UIContext.getPathForListOccurrence(int, boolean)`

    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
    Since:
      5.3.1
    See Also:
      - `newComboBox(Path)`
      - `addWidget(UIWidget)`

  - ### addWidget

    @Deprecated void addWidget(Path aPath)
    Deprecated.
    Replaced by `UIFormWriter.addWidget(Path)`
    Adds the default widget, adapted to the data type and the facets of the specified node.

    If the field is hidden according to the permission rules, then this method does nothing. If the field is read-only according to the permission rules, then a read-only component is displayed. This method does not take into account the `defaultView` property (since its application is restricted to the default view, which is not the case here).

    This method is equivalent to:

    > `aResponseContext.addWidget(aResponseContext.newBestMatching(aPath));`

    Parameters:
      `aPath` - location of the node, relative to the current node.
    Throws:
      `UnsupportedOperationException` - if the specified path refers to a node that is neither terminal nor under-terminal.
      `PathAccessException` - if the specified path is incorrect; for instance, it does not refer to an existing node or it is absolute and specifies a record node.
    Since:
      5.7.0
    See Also:
      - `newBestMatching(Path)`

  - ### addWidget

    @Deprecated void addWidget(UIWidget aWidget)
    Deprecated.
    Replaced by `UIFormWriter.addWidget(UIWidget)`
    Adds the specified widget.

    If the field is hidden according to the permission rules, then this method does nothing. If the field is read-only according to the permission rules, then a read-only component is displayed. This method does not take into account the `defaultView` property (since its application is restricted to the default view, which is not the case here).

    Parameters:
      `aWidget` - the widget to be added to this UIBean.
    Throws:
      `UnsupportedOperationException` - if the specified widget refers to a node that is neither terminal nor under-terminal.
      `PathAccessException` - if the specified path is incorrect; for instance, it does not refer to an existing node or it is absolute and specifies a record node.
    Since:
      5.5.0
    See Also:
      - `addFormRow(UIWidget)`

  - ### newComboBox

    @Deprecated UIComboBox newComboBox(Path aPath)
    Deprecated.
    Replaced by `UIFormWriter.newComboBox(Path)`
    Returns a new combo box.
    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
    Since:
      5.3.1
    See Also:
      - `addWidget(UIWidget)`

  - ### newColorPicker

    @Deprecated UIColorPicker newColorPicker(Path aPath)
    Deprecated.
    Replaced by `UIFormWriter.newColorPicker(Path)`
    Returns a new color picker.
    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
    Since:
      5.7.1
    See Also:
      - `addWidget(UIWidget)`

  - ### newBestMatching

    @Deprecated UIWidget newBestMatching(Path aPath)
    Deprecated.
    Replaced by `UIFormWriter.newBestMatching(Path)`
    Returns a new widget that will be automatically selected according to the corresponding node definition in the data model.
    Parameters:
      `aPath` - location of the target node, relative to the current node; it must refer to a node that is either terminal or under-terminal.
    Since:
      5.5.0
    See Also:
      - `addWidget(UIWidget)`

  - ### newTextBox

    @Deprecated UITextBox newTextBox(Path aPath)
    Deprecated.
    Replaced by `UIFormWriter.newTextBox(Path)`
    Returns a text input field, which can be one-line or multi-line.
    Parameters:
      `aPath` - location of the target node, relative to the current node; it must refer to a node of a simple type.
    Since:
      5.5.0
    See Also:
      - `addWidget(UIWidget)`

  - ### newTextBox

    @Deprecated UITextBox newTextBox(Path aPath, String textBoxId)
    Deprecated.
    Replaced by `UIFormWriter.newTextBox(Path)`
    Returns a text input field with specified id, which can be one-line or multi-line.
    Parameters:
      `aPath` - location of the target node, relative to the current node; it must refer to a node of a simple type.
      `textBoxId` - id of the text box HTML element
    Since:
      5.5.0
    See Also:
      - `addWidget(UIWidget)`

  - ### newTable

    @Deprecated UITable newTable(Path aPath)
    Deprecated.
    Replaced by `UIFormWriter.newTable(Path)`
    Returns a table widget
    Parameters:
      `aPath` - location of the target node, relative to the current node; it must refer to a node that is a association.
    See Also:
      - `addWidget(UIWidget)`

  - ### newDateTime

    @Deprecated UIDateTime newDateTime(Path aPath)
    Deprecated.
    Replaced by `UIFormWriter.newDateTime(Path)`
    Returns a date/time field.
    Parameters:
      `aPath` - location of the target node, relative to the current node; it must refer to a node of a simple type.
    Since:
      5.5.0
    See Also:
      - `addWidget(UIWidget)`

  - ### newCheckBox

    @Deprecated UICheckBox newCheckBox(Path aPath)
    Deprecated.
    Replaced by `UIFormWriter.newCheckBox(Path)`
    Returns a new check box widget.
    Parameters:
      `aPath` - location of the target node, relative to the current node; it must refer to a boolean or an aggregated list of a simple type and depending on an enumeration.
    Since:
      5.5.0
    See Also:
      - `addWidget(UIWidget)`

  - ### newCheckBoxGroup

    @Deprecated UICheckBoxGroup newCheckBoxGroup(Path aPath)
    Deprecated.
    Replaced by `UIFormWriter.newCheckBoxGroup(Path)`
    Returns a new check box group widget.
    Parameters:
      `aPath` - location of the target node, relative to the current node; it must refer to an aggregated list of a simple type and depending on an enumeration.
    Since:
      5.5.0
    See Also:
      - `addWidget(UIWidget)`

  - ### newDropDownList

    @Deprecated UIDropDownList newDropDownList(Path aPath)
    Deprecated.
    Replaced by `UIFormWriter.newDropDownList(Path)`
    Returns a new drop-down list.
    Parameters:
      `aPath` - location of the target node, relative to the current node; it must refer to a node of a simple type and depending on an enumeration.
    Since:
      5.5.0
    See Also:
      - `addWidget(UIWidget)`

  - ### newListBox

    @Deprecated UIListBox newListBox(Path aPath)
    Deprecated.
    Replaced by `UIFormWriter.newListBox(Path)`
    Returns a new list box.
    Parameters:
      `aPath` - location of the target node, relative to the current node; it must refer to a node of a simple type and depending on an enumeration.
    Since:
      5.5.0
    See Also:
      - `addWidget(UIWidget)`

  - ### newPassword

    @Deprecated UIPassword newPassword(Path aPath)
    Deprecated.
    Replaced by `UIFormWriter.newPassword(Path)`
    Returns a password field.
    Parameters:
      `aPath` - location of the target node, relative to the current node; it must refer to a simple type node.
    Since:
      5.7.0
    See Also:
      - `addWidget(UIWidget)`

  - ### newRadioButton

    @Deprecated UIRadioButton newRadioButton(Path aPath)
    Deprecated.
    Replaced by `UIFormWriter.newRadioButton(Path)`
    Returns a new radio button widget.
    Parameters:
      `aPath` - location of the target node, relative to the current node; it must refer to a node of a simple type and depending on an enumeration.
    Since:
      5.5.0
    See Also:
      - `addWidget(UIWidget)`

  - ### newRadioButtonGroup

    @Deprecated UIRadioButtonGroup newRadioButtonGroup(Path aPath)
    Deprecated.
    Replaced by `UIFormWriter.newRadioButtonGroup(Path)`
    Returns a new radio button group widget.
    Parameters:
      `aPath` - location of the target node, relative to the current node; it must refer to a node of a simple type and depending on an enumeration.
    Since:
      5.5.0
    See Also:
      - `addWidget(UIWidget)`

  - ### addComboBox

    @Deprecated void addComboBox(UIComboBox aWidget)
    Deprecated.
    please use `newComboBox(Path)` and `addWidget(UIWidget)`
    Adds the specified combo box component for user search and selection in a list.

    Regarding the simple HTML drop-down list, this widget facilitates the selection in the list, especially for large enumerations. Another benefit is its low cost for data transfer between the end-user browser and the application server.

    Parameters:
      `aWidget` - the combo box to be added.
    Since:
      5.3.1
    See Also:
      - `newComboBox(Path)`
      - `addWidget(UIWidget)`

  - ### addUIDropDownBox

    @Deprecated void addUIDropDownBox(Path aPath, String htmlAttributes)
    Deprecated.
    please use `newDropDownList(Path)` and `addWidget(UIWidget)`
    Adds a simple HTML drop-down for the user to select from a list.

    It is generally recommended to use the more advanced combo box.

    The list displayed in the drop-down comes from the enumeration defined by the target node (see `SchemaNode.getEnumerationList(ValueContext)`).

    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
      `htmlAttributes` - optional, the string is added to the attributes of the main HTML component
    See Also:
      - `newDropDownList(Path)`
      - `addWidget(UIWidget)`

  - ### addUIDropDownBox

    @Deprecated void addUIDropDownBox(Path aPath, String htmlAttributes, Nomenclature aSpecificNomenclature)
    Deprecated.
    please use `newDropDownList(Path)`, `UIAtomicWithEnumeration.setSpecificNomenclature(Nomenclature)` and `addWidget(UIWidget)`
    Adds a simple HTML drop-down for user selection in a list.

    It is generally recommended to use the more advanced combo box.

    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
      `htmlAttributes` - optional, the string is added to the attributes of the main HTML component
      `aSpecificNomenclature` - specifies the value-label pairs to use specifically for this component.
    See Also:
      - `newDropDownList(Path)`
      - `UIAtomicWithEnumeration.setSpecificNomenclature(Nomenclature)`
      - `addWidget(UIWidget)`

  - ### addUIListSearch

    @Deprecated void addUIListSearch(Path aPath, String htmlAttributes)
    Deprecated.
    please use `newComboBox(Path)` and `addWidget(UIWidget)`
    Adds a user input component for search and selection in a list.

    The list used for search and selection comes from the enumeration defined by the target node (see `SchemaNode.getEnumerationList(ValueContext)`).

    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
      `htmlAttributes` - optional, the string is added to the attributes of the main HTML component
    See Also:
      - `newComboBox(Path)`
      - `addWidget(UIWidget)`

  - ### addUIListSearch

    @Deprecated void addUIListSearch(Path aPath, String htmlAttributes, Nomenclature aSpecificNomenclature)
    Deprecated.
    please use `newComboBox(Path)`, `UIAtomicWithEnumeration.setSpecificNomenclature(Nomenclature)` and `addWidget(UIWidget)`
    Adds a user input component for search and selection in a list.

    For `drop-down components`, this component facilitates the selection for large enumerations. Another benefit is its low data transfer cost between the end-user browser and the application server.

    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
      `htmlAttributes` - optional, the string is added to the attributes of the main HTML component
      `aSpecificNomenclature` - specifies the "value-label" pairs to use specifically for this component.
    See Also:
      - `newComboBox(Path)`
      - `UIAtomicWithEnumeration.setSpecificNomenclature(Nomenclature)`
      - `addWidget(UIWidget)`

  - ### addUIDropDownBoxMultiple

    @Deprecated void addUIDropDownBoxMultiple(Path aPath, String htmlAttributes)
    Deprecated.
    please use `newListBox(Path)` and `addWidget(UIWidget)`
    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
      `htmlAttributes` - optional, the string is added to the attributes of the main HTML component
    See Also:
      - `newListBox(Path)`
      - `addWidget(UIWidget)`

  - ### addUILabel

    @Deprecated void addUILabel(Path aPath)
    Deprecated.
    Replaced by `WidgetWriter.addUILabel(Path)`
    Adds the standard label of the specified data model node.

    The description and additional information about the node are available in a pop-up.

    Parameters:
      `aPath` - required, location of the target, relative to the current node (for better reusability, it is advised to use a relative path)
    See Also:
      - `UIComponentWriter.addUILabel(UIFormLabelSpec)`

  - ### addUIDescription

    @Deprecated void addUIDescription(Path aPath)
    Deprecated.
    Replaced by `WidgetWriter.addUIDescription(Path)`
    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.

  - ### addUIValidationMessage

    @Deprecated void addUIValidationMessage(Path aPath)
    Deprecated.
    Replaced by `WidgetWriter.addUIValidationMessage(Path)`
    Adds the validation message associated with the specified node.

    The standard position of the validation message is below the component, and the standard position of the service button is to the right of the component.

    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
    See Also:
      - `addServiceButton(Path)`

  - ### addUIOccurrenceEditor

    @Deprecated void addUIOccurrenceEditor(Path aPath, String htmlAttributes)
    Deprecated.
    The default occurrence editor can only work with the default multi-occurrence editor. In the `UIBeanEditor.addList(UIResponseContext)` method, each occurrence can be added with the best matching display/editor with the indexed path obtained with `UIContext.getPathForListOccurrence(int)`.
    The specified path must refer to an indexed element in its last position. For example: `.[0]`
    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
      `htmlAttributes` - optional, the string is added to the attributes of the main HTML component

  - ### addUIComplexEditor

    @Deprecated void addUIComplexEditor(Path aPath, String htmlAttributes)
    Deprecated.
    please use `addWidget(Path)`
    The specified path must not refer to an indexed element in its last position.
    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
      `htmlAttributes` - optional, the string is added to the attributes of the main HTML component
    See Also:
      - `addWidget(Path)`

  - ### addUIBean

    @Deprecated void addUIBean(Path aPath, String htmlAttributes)
    Deprecated.
    please use `addWidget(Path)`
    The specified path must not refer to an indexed element in its last position.
    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
      `htmlAttributes` - optional, the string is added to the attributes of the main HTML component
    See Also:
      - `addWidget(Path)`

  - ### addUIRadioButton

    @Deprecated void addUIRadioButton(Path aPath, String htmlAttributes, boolean setCode, boolean setLabel, int index)
    Deprecated.
    please use `newRadioButton(Path)`, `UIWidget.setEditorDisabled(boolean)`, `UIAtomicWithEnumerationItem.setLabelEnabled(boolean)`, `UIAtomicWithEnumerationItem.setIndex(int)` and `addWidget(UIWidget)`
    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
      `htmlAttributes` - optional, the string is added to the attributes of the main HTML component
      `setCode` - this parameter is ignored for version 5.4.1 and higher
    See Also:
      - `newRadioButton(Path)`
      - `UIWidget.setEditorDisabled(boolean)`
      - `UIAtomicWithEnumerationItem.setLabelEnabled(boolean)`
      - `UIAtomicWithEnumerationItem.setIndex(int)`
      - `addWidget(UIWidget)`

  - ### addUIRadioButtonGroup

    @Deprecated void addUIRadioButtonGroup(Path aPath, String htmlAttributes)
    Deprecated.
    please use `newRadioButtonGroup(Path)` and `addWidget(UIWidget)`
    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
      `htmlAttributes` - optional, the string is added to the attributes of the main HTML component
    See Also:
      - `newRadioButton(Path)`
      - `addWidget(UIWidget)`

  - ### addUIRadioButtonGroup

    @Deprecated void addUIRadioButtonGroup(Path aPath, String htmlAttributes, String htmlSeparator)
    Deprecated.
    please use `newRadioButtonGroup(Path)`, `UIRadioButtonGroup.setColumnsNumber(int)` (instead of htmlSeparator) and `addWidget(UIWidget)`
    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
      `htmlAttributes` - optional, the string is added to the attributes of the main HTML component
      `htmlSeparator` - optional, a specific HTML string as value separator (display in one line: `&nbsp;`, or in column: `<br>`)
    See Also:
      - `newRadioButtonGroup(Path)`
      - `UIRadioButtonGroup.setColumnsNumber(int)`
      - `addWidget(UIWidget)`

  - ### addUITextAreaField

    @Deprecated void addUITextAreaField(Path aPath, String htmlAttributes)
    Deprecated.
    please use `newTextBox(Path)`, `UITextBox.setMultiLine(boolean)` and `addWidget(UIWidget)`
    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
      `htmlAttributes` - optional, the string is added to the attributes of the main HTML component
    See Also:
      - `newTextBox(Path)`
      - `UITextBox.setMultiLine(boolean)`
      - `addWidget(UIWidget)`

  - ### addUITextInputField

    @Deprecated void addUITextInputField(Path aPath, String htmlAttributes)
    Deprecated.
    please use `newTextBox(Path)` and `addWidget(UIWidget)`
    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
      `htmlAttributes` - optional, the string is added to the attributes of the main HTML component
    See Also:
      - `newTextBox(Path)`
      - `addWidget(UIWidget)`

  - ### addUIPasswordInputField

    @Deprecated void addUIPasswordInputField(Path aPath, String htmlAttributes)
    Deprecated.
    please use `newPassword(Path)` and `addWidget(UIWidget)`
    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
      `htmlAttributes` - optional, the string is added to the attributes of the main HTML component
    See Also:
      - `newPassword(Path)`
      - `addWidget(UIWidget)`

  - ### addUITextHiddenInputField

    @Deprecated void addUITextHiddenInputField(Path aPath, String htmlAttributes)
    Deprecated.
    please use `newTextBox(Path)` and `addWidget(UIWidget)` with a <div style="display:none;">...</div> surrounding you widget.
    Example:

                     aResponse.add("<div style=\"display:none;\">");
                     UITextBox textBox = aResponse.newTextBox(aPath);
                     aResponse.addWidget(textBox);
                     aResponse.add("</div>");

    `addJS_getNodeValue(Path)` and `addJS_setNodeValue(String, Path)` still work.
    Parameters:
      `aPath` - required, location of the target, relative to the current node; to improve reusability, use a relative path.
      `htmlAttributes` - optional, the string is added to the attributes of the main HTML component
    See Also:
      - `newTextBox(Path)`
      - `addWidget(UIWidget)`

  - ### addFormRowBestMatchingComponent

    @Deprecated void addFormRowBestMatchingComponent(Path nodePath)
    Deprecated.
    Replaced by `UIFormWriter.addFormRow(Path)`
    Adds a form row (without icon) containing the best matching component.

    If the field is hidden according to the permission rules, then this method does nothing. If the field is read-only according to the permission rules, then a read-only component is displayed. This method does not take into account the `defaultView` property (since its application is restricted to the default view, which is not the case here)..

    This method calls `addFormRowBestMatchingDisplay(Path)` or `addFormRowBestMatchingEditor(Path)`, depending on the rendering mode and permission rules.

    It is strongly recommended to surround form rows with `UIComponentWriter.startTableFormRow()` and `UIComponentWriter.endTableFormRow()` to have an automatic width for labels and benefit from the latest rendering innovations.

    Parameters:
      `nodePath` - the path of the node to display.
    Since:
      5.2.0
    See Also:
      - `addFormRowBestMatchingComponent(Path, boolean)`

  - ### addFormRow

    @Deprecated void addFormRow(UIWidget aWidget)
    Deprecated.
    Replaced by `UIFormWriter.addFormRow(UIWidget)`
    Adds a form row in the UIBean with the specified widget.

    A form row is composed of an icon, a label and the user interface widget corresponding to the specified field or group, either in read-only or read-write mode.

    If the field is hidden according to the permission rules, then this method does nothing. If the field is read-only according to the permission rules, then a read-only component is displayed. This method does not take into account the `defaultView` property (since its application is restricted to the default view, which is not the case here)..

    It is strongly recommended to surround form rows with `UIComponentWriter.startTableFormRow()` and `UIComponentWriter.endTableFormRow()` to have an automatic width for labels and benefit from the latest rendering innovations.

    Parameters:
      `aWidget` - the widget to be added to this UIBean.
    Throws:
      `UnsupportedOperationException` - if the specified widget refers to a node that is neither terminal nor under-terminal.
      `PathAccessException` - if the specified path is incorrect; for instance, it does not refer to an existing node or it is absolute and specifies a record node.
    Since:
      5.5.0

  - ### addFormRowBestMatchingComponent

    @Deprecated void addFormRowBestMatchingComponent(Path nodePath, boolean enableIcon)
    Deprecated.
    Replaced by `UIFormWriter.newFormRow(Path)`, `UIFormRow.setIconDisplayed(boolean)` and `UIFormWriter.addFormRow(UIFormRow)`
    Adds a form row with the best matching component.

    If the field is hidden according to the permission rules, then this method does nothing. If the field is read-only according to the permission rules, then a read-only component is displayed. This method does not take into account the `defaultView` property (since its application is restricted to the default view, which is not the case here).

    This method calls `addFormRowBestMatchingDisplay(Path)` or `addFormRowBestMatchingEditor(Path)`, depending on the rendering mode and permission rules.

    It is strongly recommended to surround form rows with `UIComponentWriter.startTableFormRow()` and `UIComponentWriter.endTableFormRow()` to have an automatic width for labels and benefit from the latest rendering innovations.

    Parameters:
      `nodePath` - the path of the node to display.
      `enableIcon` - `true`, includes an icon, `false`, no icon.
    Since:
      5.2.3
    See Also:
      - `addFormRowBestMatchingComponent(Path)`

  - ### addFormRowBestMatchingEditor

    @Deprecated void addFormRowBestMatchingEditor(Path nodePath)
    Deprecated.
    Replaced by `UIFormWriter.addFormRow(Path)`
    Adds a form row (no icon) with the best matching editor.

    If the field is hidden according to the permission rules, then this method does nothing. If the field is read-only according to the permission rules, then a read-only component is displayed. This method does not take into account the `defaultView` property (since its application is restricted to the default view, which is not the case here).

    It is strongly recommended to surround form rows with `UIComponentWriter.startTableFormRow()` and `UIComponentWriter.endTableFormRow()` to have an automatic width for labels and benefit from the latest rendering innovations.

    Parameters:
      `nodePath` - the path of the node to display.
    Since:
      5.2.0
    See Also:
      - `addUIBestMatchingEditor(Path, String)`

  - ### addFormRowBestMatchingEditor

    @Deprecated void addFormRowBestMatchingEditor(Path nodePath, boolean enableIcon)
    Deprecated.
    Replaced by `UIFormWriter.newFormRow(Path)`, `UIFormRow.setIconDisplayed(boolean)` and `UIFormWriter.addFormRow(UIFormRow)`
    Adds a form row with the best matching editor.

    If the field is hidden according to the permission rules, then this method does nothing. If the field is read-only according to the permission rules, then a read-only component is displayed. This method does not take into account the `defaultView` property (since its application is restricted to the default view, which is not the case here).

    It is strongly recommended to surround form rows with `UIComponentWriter.startTableFormRow()` and `UIComponentWriter.endTableFormRow()` to have an automatic width for labels and benefit from the latest rendering innovations.

    Parameters:
      `nodePath` - the path of the node to display.
      `enableIcon` - `true`, include an icon, `false`, no icon.
    Since:
      5.2.3
    See Also:
      - `addUIBestMatchingEditor(Path, String)`

  - ### addFormRowBestMatchingDisplay

    @Deprecated void addFormRowBestMatchingDisplay(Path nodePath)
    Deprecated.
    Replaced by `UIFormWriter.newBestMatching(Path)`, `UIWidget.setEditorDisabled(boolean)` and `UIFormWriter.addFormRow(UIWidget)`
    Adds a form row (without icon) with the best matching display.

    If the field is hidden according to the permission rules, then this method does nothing. This method does not take into account the `defaultView` property (since its application is restricted to the default view, which is not the case here).

    It is strongly recommended to surround form rows with `UIComponentWriter.startTableFormRow()` and `UIComponentWriter.endTableFormRow()` to have an automatic width for labels and benefit from the latest rendering innovations.

    Parameters:
      `nodePath` - the path of the node to display.
    Since:
      5.2.0
    See Also:
      - `addUIBestMatchingDisplay(Path, String)`

  - ### addFormRowBestMatchingDisplay

    @Deprecated void addFormRowBestMatchingDisplay(Path nodePath, boolean enableIcon)
    Deprecated.
    Replaced by `UIFormWriter.newBestMatching(Path)`, `UIWidget.setEditorDisabled(boolean)`, `UIFormWriter.newFormRow(Path)`, `UIFormRow.setIconDisplayed(boolean)` and `UIFormWriter.addFormRow(UIFormRow, UIWidget)`
    Adds a form row with the best matching display.

    If the field is hidden according to the permission rules, then this method does nothing. This method does not take into account the `defaultView` property (since its application is restricted to the default view, which is not the case here).

    It is strongly recommended to surround form rows with `UIComponentWriter.startTableFormRow()` and `UIComponentWriter.endTableFormRow()` to have an automatic width for labels and benefit from the latest rendering innovations.

    Parameters:
      `nodePath` - the path of the node to display.
      `enableIcon` - `true`, include an icon, `false`, no icon.
    Since:
      5.2.3
    See Also:
      - `addUIBestMatchingDisplay(Path, String)`

  - ### newFormRow

    @Deprecated UIFormRow newFormRow(Path aPath)
    Deprecated.
    Replaced by `UIFormWriter.newFormRow(Path)`
    Builds the default model-driven form row based on the specified node. Here, "default model-driven" means that the icon, label and documentation pane are computed from the data model definition.
    Parameters:
      `aPath` - location of the target node, relative to the current node.
    See Also:
      - `UIComponentWriter.newFormRow()`

  - ### addFormRow

    @Deprecated void addFormRow(UIFormRow aFormRow)
    Deprecated.
    Replaced by `UIFormWriter.addFormRow(UIFormRow)`
    Adds a complete form row in the UIBean. The specified form row must be built with `newFormRow(Path)`, the user input zone will be adapted to the data type and the facets of the underlying node.

    If the field is hidden according to the permission rules, then this method does nothing. If the field is read-only according to the permission rules, then a read-only component is displayed. This method does not take into account the `defaultView` property (since its application is restricted to the default view, which is not the case here)..

    It is strongly recommended to surround form rows with `UIComponentWriter.startTableFormRow()` and `UIComponentWriter.endTableFormRow()` to have an automatic width for labels and benefit from the latest rendering innovations.

    Parameters:
      `aFormRow` - the form row, this object shall be built by means of the method `newFormRow(Path)`.
    Throws:
      `IllegalArgumentException` - if the specified form row has not been built with `newFormRow(Path)`.
      `UnsupportedOperationException` - if the specified row's path refers to a node that is neither terminal nor under-terminal.
      `PathAccessException` - if the specified path is incorrect; for instance, it does not refer to an existing node or it is absolute and specifies a record node.
    Since:
      5.5.2

  - ### addFormRow

    @Deprecated void addFormRow(UIFormRow aFormRow, UIWidget aWidget)
    Deprecated.
    Replaced by `UIFormWriter.addFormRow(UIFormRow, UIWidget)`
    Adds a complete form row in the UIBean according to the given specification with the specified user interface widget.

    A form row is composed of an icon, a label and the user interface widget corresponding to the specified field or group, either in read-only or read-write mode.

    If the field is hidden according to the permission rules, then this method does nothing. If the field is read-only according to the permission rules, then a read-only component is displayed. This method does not take into account the `defaultView` property (since its application is restricted to the default view, which is not the case here)..

    This method is equivalent to:

    >      aResponseContext.startFormRow(aFormRow);
    >      aResponseContext.addWidget(aWidget);
    >      aResponseContext.endFormRow();

    It is strongly recommended to surround form rows with `UIComponentWriter.startTableFormRow()` and `UIComponentWriter.endTableFormRow()` to have an automatic width for labels and benefit from the latest rendering innovations.

    Parameters:
      `aFormRow` - the form row specification with the `Path` of the target node
      `aWidget` - the widget to be added to this pane.
    Throws:
      `UnsupportedOperationException` - if the specified widget refers to a node that is neither terminal nor under-terminal.
      `PathAccessException` - if the specified path is incorrect; for instance, it does not refer to an existing node or it is absolute and specifies a record node.
    Since:
      5.5.2

  - ### startFormRow

    @Deprecated void startFormRow(Path pathForLabel)
    Deprecated.
    Replaced by `UIFormWriter.startFormRow(Path)`
    Starts a form row (without icon) containing a label and plain HTML content.

    Note: The form row must be closed with UIComponentWriter.endFormRow() after creating its HTML content.

    It is strongly recommended to surround form rows with `UIComponentWriter.startTableFormRow()` and `UIComponentWriter.endTableFormRow()` to have an automatic width for labels and benefit from the latest rendering innovations.

    Parameters:
      `pathForLabel` - the path of a node to display its label.
    Since:
      5.2.0
    See Also:
      - `UIComponentWriter.startFormRow(UIFormLabelSpec)`
      - `addFormRowBestMatchingEditor(Path)`

  - ### startFormRow

    @Deprecated void startFormRow(Path pathForLabel, boolean enableIcon)
    Deprecated.
    Replaced by `UIFormWriter.newFormRow(Path)`, `UIFormRow.setIconDisplayed(boolean)` and `UIComponentWriter.startFormRow(UIFormRow)`
    Starts a form row containing an icon, a label, and plain HTML content.

    Note: The form row must be closed with UIComponentWriter.endFormRow() after creating its HTML content.

    It is strongly recommended to surround form rows with `UIComponentWriter.startTableFormRow()` and `UIComponentWriter.endTableFormRow()` to have an automatic width for labels and benefit from the latest rendering innovations.

    Parameters:
      `pathForLabel` - the path of a node to display its label.
      `enableIcon` - `true` to enable the icon, `false` to have no icon.
    Since:
      5.2.3
    See Also:
      - `UIComponentWriter.startFormRow(UIFormLabelSpec)`
      - `addFormRowBestMatchingEditor(Path)`

  - ### newFormGroup

    @Deprecated UIFormGroup newFormGroup(Path aPath)
    Deprecated.
    Replaced by `UIFormWriter.newFormGroup(Path)`
    Builds the default model-driven form group based on the specified node. Here, "default model-driven" means the label, the documentation pane and the initial state of the group (expanded or collapsed) are computed from the data model definition.
    Parameters:
      `aPath` - location of the target node, relative to the current node.
    Since:
      5.7.0
    See Also:
      - `UIComponentWriter.newFormGroup(UIFormLabelSpec)`
      - `UIComponentWriter.startFormGroup(UIFormGroup)`

  - ### startFormGroup

    @Deprecated void startFormGroup(Path aPath)
    Deprecated.
    Replaced by `UIFormWriter.startFormGroup(Path)`
    Starts a form group for the node at the given path.

    This method displays the default model-driven form group based on the specified node. Here, "default model-driven" means that the label, the documentation pane and the initial state of the group (expanded or collapsed) are computed from the data model definition.

    This method is equivalent to:

    > `aResponseContext.startFormGroup(aResponseContext.newFormGroup(aPath));`

    It is mandatory to surround a form group with `UIComponentWriter.startTableFormRow()` and `UIComponentWriter.endTableFormRow()` to have an automatic width for labels and benefit from the latest rendering innovations.

    Note: The form group must be ended with UIComponentWriter.endFormGroup() to stop the indentation.

    Parameters:
      `aPath` - location of the target node, relative to the current node.
    Throws:
      `PathAccessException` - if the specified path is incorrect; for instance, it does not refer to an existing node or it is absolute and specifies a record node.
      `IllegalStateException` - if `UIComponentWriter.startTableFormRow()` was not called before.
    Since:
      5.7.0
    See Also:
      - `UIComponentWriter.startFormGroup(UIFormGroup)`
      - `UIComponentWriter.startFormGroup(UIFormLabelSpec)`

  - ### doEnsureValueIsDefined

    void doEnsureValueIsDefined()
    Deprecated.
    Pre-instantiates a value for the current node. This is necessary to generate the user interface with adequate default values and structure.

  - ### getTableCellStyleHandler

    @Deprecated UITableCellStyleHandler getTableCellStyleHandler() throws IllegalStateException
    Deprecated.
    Replaced by `WidgetWriter.getTableCellStyleHandler()`
    This method allows customizing the look of a table cell.

    It can only be invoked in the context of the method `UIBeanEditor.addForDisplayInTable(UIResponseContext)`.

    Returns:
      the UITableCellStyleHandler to add styles on the current cell.
    Throws:
      `IllegalStateException` - if this method is called outside of a table cell.
    Since:
      5.2.0

  - ### setCellContentWithButtonOnRight

    void setCellContentWithButtonOnRight(String aString, UIButtonSpec aButton) throws IllegalStateException
    Deprecated.
    This method can be used to include content in a table cell with a button to the right.

    It can only be invoked in the context of the method `UIBeanEditor.addForDisplayInTable(UIResponseContext)`).

    This style of presentation is used for 'Preview' button in tables, for example.

    The button stays aligned to the right of the cell, and on most browsers, if there is not enough space to display the entire text, the text is truncated and displayed with an ellipsis.

    The button style will be forced using the following instructions:
    `aButton.setButtonLayout(UIButtonLayout.ICON_ONLY);
    aButton.setRelief(UIButtonRelief.FLAT);
    aButton.setCssClass(...);
    ` Thus, any previously defined button layout properties, such as the relief and CSS classes, will be lost.

    Note: if content is added after calling this method, an `IllegalStateException` is raised.

    Parameters:
      `aString` - cell content (HTML or simple text)
      `aButton` - the right-aligned button
    Throws:
      `IllegalStateException` - if this method is called outside of a table cell or if content has been added before.
    Since:
      5.4.2

  - ### jsBufferAddJavaScriptExpression

    @Deprecated UIResponseContext jsBufferAddJavaScriptExpression(String aJavaScriptExpression)
    Deprecated.
    This method is inactive except if extending `UIBeanEditorV4`. Use `UIJavaScriptWriter.addJS(String)` instead.
    Adds a JavaScript expression to JavaScript writer.

  - ### jsBufferAddString

    @Deprecated UIResponseContext jsBufferAddString(String aString)
    Deprecated.
    Use `UIJavaScriptWriter.addJS(String)` or `UIBodyWriter.add(String)` instead.
    If extending `UIBeanEditorV4`, adds a String to JavaScript writer. Otherwise, adds a String to the HTTP output stream.

  - ### jsBufferEndOfLine

    @Deprecated UIResponseContext jsBufferEndOfLine()
    Deprecated.
    This method is not used unless extending `UIBeanEditorV4`. Use `UIJavaScriptWriter.addJS_cr()` or `UIBodyWriter.add_cr()` instead.
    Adds an end of line when adding content to the JavaScript writer.

  - ### jsBufferInitalize

    @Deprecated UIResponseContext jsBufferInitalize()
    Deprecated.
    This method is not used unless extending `UIBeanEditorV4`.
    Initializes a JavaScript writer.

  - ### jsBufferNewLine

    @Deprecated UIResponseContext jsBufferNewLine()
    Deprecated.
    This method is not used unless extending `UIBeanEditorV4`. Use `UIJavaScriptWriter.addJS_cr()` or `UIBodyWriter.add_cr()` instead.
    Continue adding content to JavaScript writer as a new line of JavaScript code

  - ### jsBufferReenable

    @Deprecated UIResponseContext jsBufferReenable(boolean isJsBufferWritingModeTemporaryDisabled)
    Deprecated.
    This method is inactive except if extending `UIBeanEditorV4`.
    Ensures JavaScript buffer writing mode is re-enabled.

    The boolean argument must be the result of a previous call to method `jsBufferTemporaryDisable()`.

    See Also:
      - `jsBufferTemporaryDisable()`
      - `jsBufferNewLine()`

  - ### jsBufferTemporaryDisable

    @Deprecated boolean jsBufferTemporaryDisable()
    Deprecated.
    This method is inactive except if extending `UIBeanEditorV4`.
    Ensures JavaScript buffer writing mode is temporary disabled.

    Returns `true` if current mode was writing to the JavaScript buffer.

    See Also:
      - `jsBufferNewLine()`
      - `jsBufferReenable(boolean)`

  - ### enableEscapedHtml

    @Deprecated void enableEscapedHtml(boolean enabled)
    Deprecated.
    See `UIBeanEditorV4`.
    Temporarily enables or disables writing escaped HTML to the stream.
    See Also:
      - `isEscapedHtmlEnable()`

  - ### isEscapedHtmlEnable

    @Deprecated boolean isEscapedHtmlEnable()
    Deprecated.
    See `UIBeanEditorV4`.
    Tests whether output stream is currently escaping HTML.
    See Also:
      - `enableEscapedHtml(boolean)`

  - ### getNextHtmlTabIndex

    @Deprecated int getNextHtmlTabIndex()
    Deprecated.
    `TabIndexes` are no longer used in forms, the default order (no `tabIndex`) is preferable. Currently, the `tabIndex` attribute is used with the value '-1' to keep the keyboard from having focus (i.e. control buttons of a field)
    Returns the next value for the HTML tab index in the response.
    See Also:
      - https://www.w3.org/TR/html4/interact/forms.html#adef-tabindex

  - ### addJS_getNodeValue

    @Deprecated UIJavaScriptWriter addJS_getNodeValue(Path aPath)
    Deprecated.
    Replaced by `UIFormWriter.addJS_getNodeValue(Path)`
    Adds JavaScript code to get the current value of a node as set in the form.

    For more information and usage, see `UIFormWriter.addJS_getNodeValue(Path)`.

    Parameters:
      `aPath` - location of the target node, relative to the current node.
    Since:
      5.3.1
    See Also:
      - `UIFormWriter.addJS_getNodeValue(Path)`

  - ### addJS_setNodeValue

    @Deprecated UIJavaScriptWriter addJS_setNodeValue(String aVarName, Path aPath)
    Deprecated.
    Replaced by `UIFormWriter.addJS_setNodeValue(String, Path)`
    Adds JavaScript code to set the value of a node from a JavaScript variable.

    For more information and usage, see `UIFormWriter.addJS_setNodeValue(String, Path)`.

    Parameters:
      `aVarName` - the name of a JavaScript variable containing the value, or the raw value.
      `aPath` - location of the target node, relative to the current node.
    Since:
      5.3.1
    See Also:
      - `UIFormWriter.addJS_setNodeValue(String, Path)`

  - ### getPrefixedPath

    @Deprecated Path getPrefixedPath(Path aPath)
    Deprecated.
    Replaced by `UIFormWriter.getPrefixedPath(Path)`
    Gets the prefixed path. This method is useful when using JavaScript methods `JavaScriptCatalog.ebx_form_getValue(String)` and `JavaScriptCatalog.ebx_form_setValue(String, Object)`.
    Since:
      5.8.0